package ala2D;

import java.awt.Color;
import java.util.LinkedList;

public class Chan extends ConvexHullAlgorithem {
	private Point[] p; // array of points
    private LinkedList<Point> l = new LinkedList<Point>();
	private LinkedList<Line> l2 = new LinkedList<Line>();
	private MainPanel mainPanel = MainPanel.getInstance();
	private int time = 100;
	private int m = 1, t = 1;
	
	
    public void set(Point[] q) {
        p=q;
        m = 3;//p.length;
        t = p.length / m;
    }
    
    public Point[] get(){

    	Point[] result = new Point[l.size()];
    	for(int i=0;i<l.size();i++)
    		result[i] = l.get(i);
    	return result;
    }

    public void setTime(int time){
    	this.time = time;
    }

    /** exchanges two points p[i] and p[j]
     */
    private void exchange(int i, int j)
    {
        Point t=p[i];
        p[i]=p[j];
        p[j]=t;
    }


    /** computes coordinates of all points relative to point p0
     */
    private void makeRelativeTo(Point p0)
    {
        int i;
        Point p1=new Point(p0); // notwendig, weil p0 in p[] sein kann
        for (i=0; i<p.length; i++)
            p[i].makeRelativeTo(p1);
    }
    
    /** determines index of a point with minimum y-coordinate
     */
    private int indexOfLowestPoint(Point[] pt)
    {
        int i, min=0;
        for (i=1; i<pt.length; i++)
            if (pt[i].isLower(pt[min]))
                min=i;
        return min;
    }
    
    private Point[] getPartOfArray(int lo, int hi){
    	Point[] des = new Point[(hi-lo)];
    	int c = 0;
    	
    	for(int i=lo;i<hi;i++){
    		des[c++] = p[i];
    	}
    	
    	return des;
    }
    
  /** computes hull points with the chan algorithm
 */
private void chan(){
	Point[] des = new Point[p.length];
	Point[] tmp;
	GrahamScan ch;
//	Thread t;
	int count = 0;
	
	ch = new GrahamScan();
	
	for(int i=0;i<p.length;i+=t){
		ch = new GrahamScan();
		
		if(i+t >= p.length)
			tmp = getPartOfArray(i, p.length);
		else
			tmp = getPartOfArray(i, i+t);
		
		if(tmp.length >= 3){
			ch.set(tmp);
			ch.setTime(this.time);
			ch.grahamScan();
		
//				t = new Thread(ch);
//				t.start();
//				
//				try {
//					Thread.sleep(1000);
//				} catch (InterruptedException e) {
//		
//				}
		
			tmp = ch.get();
			

//			Point[] pp= tmp; 
//							
//			//int anz= j.get();
//			
//			Line [] line = new Line[pp.length];
//			
//			for(int k=1; k<pp.length; k++)
//				line[k-1] = new Line(pp[k-1],pp[k], Color.GREEN);
//				
//			
//			line[pp.length-1] = new Line(pp[0],pp[pp.length-1], Color.GREEN);
//				
//			mainPanel.addPaintable(line);
//			mainPanel.repaint();
		}
		
		for(int j=0;j<tmp.length;j++)
			des[count++] = tmp[j];
		
		try {
			Thread.sleep(time);
		} catch (InterruptedException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}
	
//	mainPanel.removeAllPaintable();
//	mainPanel.addPaintable(p);
	
	if(count > 0){
		tmp = new Point[count];
		
		for(int j=0;j<count;j++){
			tmp[j] = des[j];
		}
		
		JarvisMarch cj = new JarvisMarch();
		cj.set(tmp);
		cj.setTime(this.time);
		cj.jarvisMarch();
//		t = new Thread(cj);
//		t.start();
//		try {
//			this.wait();
//		} catch (InterruptedException e) {
//			// TODO Auto-generated catch block
//		}
		tmp = cj.get();
		
		for(int i=0;i<tmp.length;i++)
			l.add(tmp[i]);
		
		mainPanel.removeAllPaintable();
		mainPanel.addPaintable(p);

		Point[] pp= tmp; 
						
		//int anz= j.get();
		
		Line [] line = new Line[pp.length];
		
		for(int i=1; i<pp.length; i++)
			line[i-1] = new Line(pp[i-1],pp[i], Color.RED);
			
		
		line[pp.length-1] = new Line(pp[0],pp[pp.length-1], Color.RED);
			
		mainPanel.addPaintable(line);
		mainPanel.repaint();
	}
}   
    
public double checkPoint(Point a, Point b, Point c){
    	
    	double ax = a.x - b.x;
    	double ay = a.y - b.y;
    	double bx = c.x - b.x;
    	double by = c.y - b.y;
    	
    	return Math.acos((ax*bx + ay*by) / (Math.sqrt(ax*ax + ay*ay) * Math.sqrt(bx*bx + by*by)));	
    }

	public void run() {
		chan();	
//		this.notifyAll();
	}

	@Override
	public void set(int m) {
		this.m = m;
		 t = p.length / m;
		
	}
}
