package ala2D;

import java.awt.Color;
import java.util.LinkedList;

public class JarvisMarch extends ConvexHullAlgorithem 
{

	private Point[] p;
	private LinkedList<Point> l = new LinkedList<Point>();
	private MainPanel mainPanel = MainPanel.getInstance();
	private int time = 100;
	
	
    public void set(Point[] q) {
        p=q;
    }
    
    public Point[] get(){

    	Point[] result = new Point[l.size()];
    	for(int i=0;i<l.size();i++)
    		result[i] = l.get(i);
    	return result;
    }

    public void setTime(int time){
    	this.time = time;
    }
    /** determines index of a point with minimum y-coordinate
     */
    private int indexOfLowestPoint() {
        int i, min=0;
        for (i=1; i<p.length; i++)
            if (p[i].isLower(p[min]))
                min=i;
        return min;
    }

    
    public void jarvisMarch() {
    	int i=indexOfLowestPoint();
    	l.add(p[i]);
    	int curr=i;
    	int k = 0;
    	double alpha;
    	double temp;
    	
    	
    	Point pv = new Point(p[i].x-20, p[i].y, Color.CYAN);
    	
       	mainPanel.addPaintable(pv);
    	
    	Point pt = pv;
    	Line searchLine, posibleLine = null;

    	do {
    		alpha = Double.MIN_VALUE;
    		temp=0;
    		curr = 0;
    		
	    	for(int j=0; j<p.length;j++){

	    		temp = checkPoint(pt, p[i], p[j]);
	    		
//	        	System.out.println(j+". c: "+p[j].getKey()+" W: "  +temp);
	        	
	        	searchLine = new Line(p[i], p[j], Color.MAGENTA);
	        	
	        	mainPanel.addPaintable(searchLine);
	        	mainPanel.revalidate();
	        	mainPanel.repaint();
	        	
	        	if(temp>alpha && p[i] != p[j]){
	        		
	        		if(posibleLine!=null) mainPanel.removePaintable(posibleLine);
	        		alpha = temp;
	        		curr = j;
	        		posibleLine = new Line(p[i], p[j], Color.GREEN);
		        	mainPanel.addPaintable(posibleLine);
		        	mainPanel.revalidate();
		        	mainPanel.repaint();
	        	}
	        	
	        	try {
					Thread.sleep(time);
				} catch (InterruptedException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
				mainPanel.removePaintable(searchLine);
				mainPanel.revalidate();
				mainPanel.repaint();
	        	
	    	}
	    	//if(posibleLine!=null) mainPanel.removePaintable(posibleLine);
	    	posibleLine.setColor(Color.RED);
	       	mainPanel.addPaintable(posibleLine);
	       	mainPanel.revalidate();
        	mainPanel.repaint();
        	posibleLine = null;
        	
    
	    	l.add(p[curr]);
	    	
	    	pt = p[i];
	    	i = curr;
	    	k++;
	    	
	    }
    	while(p[curr]!=l.get(0));
    }
    

    public double checkPoint(Point a, Point b, Point c){
    	
    	double ax = a.x - b.x;
    	double ay = a.y - b.y;
    	double bx = c.x - b.x;
    	double by = c.y - b.y;
    	
    	return Math.acos((ax*bx + ay*by) / (Math.sqrt(ax*ax + ay*ay) * Math.sqrt(bx*bx + by*by)));
    }

	public void run() {
		jarvisMarch();
//		this.notifyAll();
	}

	@Override
	public void set(int m) {
		// TODO Auto-generated method stub
		
	}

}
