package ala2D;
import java.applet.Applet;
import java.awt.Color;
import java.awt.Component;
import java.awt.Container;
import java.awt.Dimension;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Insets;
import java.awt.Toolkit;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.Random;

import javax.swing.JApplet;
import javax.swing.JButton;
import javax.swing.JComboBox;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JTextField;

public class MainFrame extends JApplet{
	
	private int points = 50;
	private MainPanel mainPanel;
	private JPanel controlPanel;
	private Point[] p;
	Random rand = new Random(System.currentTimeMillis());
	Thread t;
	private final static int dist = 5;
	private JButton initPointsButton = new JButton("init Points");
	private JButton hullPointsButton = new JButton("convex Hull");
	private JComboBox algoBox = new JComboBox();
	private JLabel choiceLabel = new JLabel("Algorithmus :"); 
	private JLabel timerLabel = new JLabel("Verzgerung :");  
	private JLabel pointLabel = new JLabel("Anzahl Punkte :"); 
	private JLabel mLabel = new JLabel("m (anzahl Teilungen) :"); 
	private JLabel pgLabel = new JLabel("Punktgre :"); 
	private JTextField timerTextField;
	private JTextField pointTextField;
	private JTextField mTextField;
	private JTextField pgTextField;
	
	private int m = 3;
	
	static void addComponent( Container cont,
              GridBagLayout gbl,
              Component c,
              int x, int y,
              int width, int height,
              double weightx, double weighty, Insets insets) {
		
		GridBagConstraints gbc = new GridBagConstraints();
		gbc.fill = GridBagConstraints.BOTH;
		gbc.gridx = x; gbc.gridy = y;
		gbc.gridwidth = width; gbc.gridheight = height;
		gbc.weightx = weightx; gbc.weighty = weighty;
		gbc.insets = insets;
		gbl.setConstraints( c, gbc );
		cont.add( c );

	}
	
	
	public void init(){
			
	    GridBagLayout gbl = new GridBagLayout();
	    setLayout( gbl );
	    
	    GridBagLayout gbl2 = new GridBagLayout();
	    controlPanel = new JPanel();
	    controlPanel.setLayout(gbl2);


//		timerLabel.setBounds(this.getWidth()/8,this.getHeight()-150,this.getWidth()/8,30);
//		pointLabel.setBounds(this.getWidth()/8,this.getHeight()-150 + 40,this.getWidth()/8,30);
//		this.add(timerLabel);
//		this.add(pointLabel);
		
		mTextField = new JTextField("6");
		pgTextField = new JTextField("6");
		
		mLabel.setVisible(false);
		mTextField.setVisible(false);
		
//		
		timerTextField = new JTextField("100");
		//timerTextField.setBounds(2*this.getWidth()/8,this.getHeight()-150,this.getWidth()/8,30);
		pointTextField = new JTextField("60");
//		pointTextField.setBounds(2*this.getWidth()/8,this.getHeight()-150 + 40,this.getWidth()/8,30);
//		this.add(timerTextField);
//		this.add(pointTextField);
		
//		choiceLabel.setBounds(this.getWidth()/8,this.getHeight()-150 + 80,this.getWidth()/8,30);
//		this.add(choiceLabel);
		
		algoBox.setBounds(2*this.getWidth()/8,this.getHeight()-150 + 80,this.getWidth()/8+(this.getWidth()/8 / 2),30);
		algoBox.addItem("Gift wrapping");
		algoBox.addItem("Graham Scan");
		algoBox.addItem("Chan");
		algoBox.setSelectedIndex(0);
//		this.add(algoBox);
		
		algoBox.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent arg0) {
				if(MainFrame.this.algoBox.getSelectedItem().equals("Chan")){
					mLabel.setVisible(true);
					mTextField.setVisible(true);
				}
				else{
					mLabel.setVisible(false);
					mTextField.setVisible(false);
				}
			}
		});
				
		mainPanel = MainPanel.getInstance();
		mainPanel.setBounds(20,20,this.getWidth()-40,this.getHeight()-180);
//		this.add(mainPanel);

		initPointsButton.addActionListener(new ActionListener(){
			@SuppressWarnings("deprecation")
			public void actionPerformed(ActionEvent arg0) {
				Point.gr = Integer.parseInt(pgTextField.getText());
				points = Integer.parseInt(pointTextField.getText());
				m = Integer.parseInt(mTextField.getText());
				if(points > 2){
					
					if(t!=null) t.stop();
				
				
					mainPanel.removeAllPaintable();
					p = new Point[points];
					for(int i=0;i<points;i++)
						p[i] = new Point(i,(mainPanel.getWidth()-10)*rand.nextDouble(),(mainPanel.getHeight()-10)*rand.nextDouble());
						
					mainPanel.addPaintable(p);
					mainPanel.repaint();
				}
			}
		});
		
		initPointsButton.setBounds(4*this.getWidth()/8,this.getHeight()-150,this.getWidth()/8,30);
//		this.add(initPointsButton);

		hullPointsButton.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent arg0) {
				
				int index = algoBox.getSelectedIndex();
				ConvexHullAlgorithem j;

				
				if(index == 0)
					 j = new JarvisMarch();
				else if(index == 1)
					 j = new GrahamScan();
				else if(index == 2)
					 j = new Chan();
				else
					 j = new JarvisMarch();
				
				j.set(p);
				j.set(m);
				
				int time = Integer.parseInt(timerTextField.getText());
				
				if(time >= 0)
					j.setTime(time);
				
				t = new Thread(j);
				t.start();
			}
		});
		hullPointsButton.setBounds(6*this.getWidth()/8,this.getHeight()-150,this.getWidth()/8,30);
//		this.add(hullPointsButton);
		
		
	    //                                      			x  y  w  h  wx   wy
	    addComponent( this, gbl, mainPanel, 				0, 0, 1, 5, 1.0, 1.0, 	new Insets(5,5,5,5) );
	    addComponent( this, gbl, controlPanel, 				0, 6, 1, 1, 0,   0, 	new Insets(0,0,0,0) );
	    	    
	    addComponent( controlPanel, gbl2, choiceLabel, 		0, 0, 1, 1, 0, 0, 	  	new Insets(0,20,dist,0));
	    addComponent( controlPanel, gbl2, algoBox, 			1, 0, 1, 1, 0, 0, 	  	new Insets(0,20,dist,0));
	   
	    addComponent( controlPanel, gbl2, timerLabel, 		0, 1, 1, 1, 0, 0, 		new Insets(0,20,dist,0));
	    addComponent( controlPanel, gbl2, timerTextField,   1, 1, 1, 1, 1.0, 0, 	new Insets(0,20,dist,0));
	   
	    addComponent( controlPanel, gbl2, pointLabel, 		0, 2, 1, 1, 0, 0, 		new Insets(0,20,dist,0));
	    addComponent( controlPanel, gbl2, pointTextField,   1, 2, 1, 1, 0, 0, 		new Insets(0,20,dist,0));
	  
	    addComponent( controlPanel, gbl2, pgLabel, 			0, 3, 1, 1, 0, 0, 		new Insets(0,20,dist,0));
	    addComponent( controlPanel, gbl2, pgTextField,   	1, 3, 1, 1, 0, 0, 		new Insets(0,20,dist,0));

	    addComponent( controlPanel, gbl2, mLabel, 			0, 4, 1, 1, 0, 0, 		new Insets(0,20,dist,0));
	    addComponent( controlPanel, gbl2, mTextField,   	1, 4, 1, 1, 0, 0, 		new Insets(0,20,dist,0));
	    
	    addComponent( controlPanel, gbl2, initPointsButton,	2, 0, 2, 1, 1.0, 0, 	new Insets(0,30,dist,0));
	    addComponent( controlPanel, gbl2, hullPointsButton,	2, 1, 2, 1, 1.0, 0, 	new Insets(0,30,dist,0));
	    addComponent( controlPanel, gbl2, new JPanel(),		2, 2, 2, 3, 1.0, 1.0, 	new Insets(0,0,0,0));
	    
//	    addComponent( this, gbl, new JButton("5"), 0, 3, 2, 1, 0  , 0   );
//	    addComponent( this, gbl, new JButton("6"), 0, 4, 2, 1, 0  , 0   );
//	    addComponent( this, gbl, new JButton("7"), 2, 3, 1, 2, 0  , 0   );

		
		this.setVisible(true);
	}
}
