package ala2D;
import java.awt.BasicStroke;
import java.awt.Color;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.util.HashMap;
import java.util.Iterator;

import javax.swing.JLayeredPane;

public class MainPanel extends JLayeredPane {
	
	HashMap<String,Paintable> painableMap;
	BasicStroke pointStroke = new BasicStroke(5);
	private static MainPanel instance;
	
	
	private MainPanel(){
		super();
		painableMap = new HashMap<String,Paintable>();
	}
	public static MainPanel getInstance(){
		if(instance==null)instance = new MainPanel();
		return instance;
	}
	
	public void removePaintable(Paintable pa){
		painableMap.remove(pa.getKey());	
	}
	

	public void addPaintable(Paintable[] p){
		for(int i=0; i<p.length; i++)
			addPaintable(p[i]);
	}

	public void addPaintable(Paintable p){
		painableMap.put(p.getKey(),p);
	}
	
	public void removePaintableOblect(Paintable p){
		painableMap.remove(p);
	}
	
	public void removeAllPaintable(){
		painableMap.clear();
	}
	
	
	public void paint(Graphics g) {
		try{
			super.paint(g);
			g.setColor(Color.WHITE);
			g.fillRect(0,0,this.getWidth(),this.getHeight());
			
			
			Graphics2D g2d = (Graphics2D) g;
			
			Iterator<Paintable> iter = painableMap.values().iterator();
			while(iter.hasNext()){
				Paintable p = iter.next();
				p.paintMe(g2d);			
			}
		}catch(Exception e){
			
		}
	}


}
